import time, os, signal, sys

from Thump import Mp3, CoreApp
from Thump.Io import ThumpLogs, SockQueue

class Player(CoreApp.CoreApp):

  def __init__(self):
    self.errorLog = ThumpLogs.PlayerErrorLog()

    CoreApp.__init__(self)

    self.accessLog = ThumpLogs.PlayerAccessLog()

    self.queues["queue"] = SockQueue.PlayerToQueue()
    self.queues["decoder"] = None

    self.commands.extend([ "play", "stop", "seek", "pause" ])


  #

  def seek(self):
    self.errorLog.debug("Player: seek: running...")
    self.queues["decoder"].seek(msg["data"])
    self.errorLog.debug("Player: seek: done")

  def stop(self):
    self.queues["decoder"] = None
    self.queues["queue"].send("done")

  def pause(self):
    self.queues["decoder"].pause()

  def play(self):
    song = self.msg["data"]
    
    print "song is ->", song

    self.errorLog.debug("Player: playSong: playing %s" % song)

    self.accessLog.access(song)

    try:
      self.queues["decoder"] = Mp3.Mp3(song)
      self.queues["decoder"].play()
    except IOError, err:
      self.errorLog.debug("Player: playSong: %s" % err)
      self.errorLog.error(err)




class testq:
  import readline, time
  msg,testcmd,second,count = dict(),"play /home/music/n-z/xenogears/xenogears - in a dark sleep.mp3",0,0
  def pop(self):
    if 1: return self.test()
    try:
      text = raw_input("thump > ").strip()
      if text == "test": text = self.testcmd
      s = text.find(" ")
      return {"command":(s!=-1 and text[:s] or text).strip(),"data":(s!=-1 and text[s:] or "").strip()}
    except EOFError:
      print; import sys; sys.exit(0)

  cmds = ({"command":"stop","data":""}, {"command":"pause","data":""},
          {"command":testcmd.split()[0], "data":testcmd[testcmd.find(" ")+1:]})
  def test(self):
    time.sleep(random.randrange(0, 1)/float(10)); tm = time.time()
    if not int(str(tm).split(".")[0]) == self.second:
      self.second, self.count = int(str(tm).split(".")[0]), 0
    self.count +=1; print self.count
    return random.choice(self.cmds)

  __len__ = lambda *a: 1



class fakelog:
  debug = error = warning = info = critical = access = lambda *a: None

if __name__ == "__main__":
  try:
    import random
    player = Player()
    #player.q = testq()
    #player.errorLog = player.accessLog = fakelog()
    player.mainloop()
  except KeyboardInterrupt:
    sys.exit()


