import time, os, signal, sys

from Thump import CoreApp
from Thump.Io import ThumpLogs, SockQueue

class QueueManager(CoreApp.CoreApp):

  def __init__(self):
    self.errorLog = ThumpLogs.QueueErrorLog()

    CoreApp.__init__(self)

    self.commands.append("done")

    self.queues["player"] = SockQueue.QueueToPlayer()
    self.queues["outside"] = SockQueue.QueueToOutside()

    self.playlist = Playlist.Playlist()

  #

  def done(self):
    print "player says it's done, sending another play command"
    self.player.send("play " + self.queues["playlist"].get())
    print "done sending"


if __name__ == "__main__":
  try:
    q = QueueManager()
    q.mainloop()
  except KeyboardInterrupt:
    sys.exit()


