from os import mkdir
from os.path import join, expanduser, exists
from sys import stderr, exit
from logging import DEBUG

"""
In this file we assume we have none of the logging facilities or anything that
the majority of Thump has available.  If something goes wrong, just print to
stderr and die.
"""

###################
#      files      #
###################

# directory

homeConfDir = join(expanduser("~"), ".thump")

if not exists(homeConfDir):
  try:
    mkdir(homeConfDir, 0755)
  except OSError:
    print >>stderr, homeConfDir, "doesn't exist, and I can't create it!"
    print >>stderr, "I need this directory.  HTH, HAND."
    exit(1)

# names

basenames = {
 #internal name/actual filename
  "Playlist"     : "playlist",
  "PlayerAccess" : "access_log",
  "PlayerErrors" : "error_log",
  "QueueErrors"  : "q_error_log",
  "Stderr"       : "stderr_out"
}

# full paths

filenames = dict()
for ourname, filename in basenames.items():
  filenames[ourname] = join(homeConfDir, filename)


##################
#      logs      #
##################

logLevel = DEBUG

logEntryFormat = "%(asctime)s %(process)s %(levelname)s %(message)s"

playerAccessMsg = "Playing file: %s"


##################
# ports and ips  #
##################

# TODO: change so that you can specify to use unix sockets
# (and edit their filenames here)

addresses = {
  "player": "127.0.0.1",
  "queue": "127.0.0.1"
}

ports = {
  #port on which the player listens for msgs from the queue
  "playerToQueue": 4802,
  #port on which the queue listens for msgs from the player
  "queueToPlayer": 4801,
  #port on which the queue listens for input from frontend apps
  "queueToOutside": 4800
}

