import time

from Thump.Io import ThumpLogs

class CoreApp(object):

  granularity = 0.05

  commands = [ "die" ]

  queues = {}

  def __init__(self):
    if not self.errorLog:
      self.errorLog = ThumpLogs.NullLog()

    self.errorLog.debug("Hello world")

  def command(self):
    method = getattr(self, self.msg["command"])
    method()

  def handleCommand(self):
    if self.msg["command"] in self.commands:
      self._handleValidCommand()
    else:
      self.errorLog.error("Unknown command: %s" % self.msg["command"])

  def _handleValidCommand(self):
    self.command()

  def flushQueues(self):
    didSomething = False

    for q in self.queues.values():
      if not q:
        break

      q.update()
      while 1:
        if q.size():
          self.msg = q.get()
          if self.msg:
            self.handleCommand()
          didSomething = True
        else:
          break

    return didSomething

  def mainloop(self):
    self.errorLog.debug("mainloop: running")
    while 1:
      ret = self.mainloopIter()
      
      if ret is True:
        time.sleep(self.granularity)
      elif ret is False:
        break

  def mainloopIter(self):
    if not self.flushQueues():
      return True

  def die(self):
    self.errorLog.info("Exiting")
    sys.exit(0)
    self.errorLog.critical("How did I get here?")

