import os

from Thump.Values import Filenames

class Fifo:

  def __init__(self, filename):
    if not os.path.exists(filename):
      os.mkfifo(filename)

    self.fifo = os.open(filename, os.O_RDWR|os.O_NDELAY)

  def write(self, text):
    os.write(self.fifo, text)

  def read(self):
    try:
      return os.read(self.fifo, 4096)
    except OSError:
      return None

  def readlines(self):
    text = self.read()
    return text is None and [] or [ line.strip() for line in text.split("\n") ]


class PlayerFifo(Fifo):
  def __init__(self):
    Fifo.__init__(self, Filenames.daemonfifo)

class QueueFifo(Fifo):
  def __init__(self):
    Fifo.__init__(self, Filenames.queuefifo)
