from Logs import Log
from Thump.Configuration import filenames, logLevel, logEntryFormat, playerAccessMsg


class ThumpLog(Log):
  def __new__(cls, name, level=logLevel, format=logEntryFormat):
    return Log.__new__(cls, 'Thump.%s'%name, filenames[name], level, format)


class PlayerAccessLog(ThumpLog):
  def __new__(cls):
    log = ThumpLog.__new__(cls, "PlayerAccess")
    log.access = lambda filename: log.info(playerAccessMsg % filename)
    return log


class PlayerErrorLog(ThumpLog):
  def __new__(cls):
    return ThumpLog.__new__(cls, "PlayerErrors")

class QueueErrorLog(ThumpLog):
  def __new__(cls):
    return ThumpLog.__new__(cls, "QueueErrors")

class NullLog:
  critical=fatal=error=warning=warn=info=debug=notset=lambda *a:None

