import popen2, os, sys, select, time

class Mp3(object):

  fields = """
  modeExtension channels bitrate sampleRate  protected  extension
  bytesPerFrame emphasis version copyrighted modeString layer
  """.strip().split()

  frameFields = """
  framesRemaining timeRemaining currentFrame currentTime totalTime
  """.strip().split()

  buf = ""
  done = False

  def __init__(self, filename):
    self.initAttrs()
    self.filename = filename
    self.getDecoder()

  def __del__(self):
    if not self.done:
      try: self.quit()
      except: pass

  def size(self):
    pass

  def get(self):
    if self.done:
      return {"command":"stop", "param":"", "data":""}

  def initAttrs(self):
    map(lambda pair:map(lambda x:setattr(self,x,pair[0]),pair[1]),
        (("",self.fields),(0,self.frameFields)))

  def updateFields(self, args):
    map(lambda pair:setattr(self,pair[0],pair[1]),
        zip(self.fields, args.split()))

  def updateFrameFields(self, args):
    map(lambda pair:setattr(self,pair[0],pair[1]),
        zip(self.frameFields, args.split()))

  def getDecoder(self):
    for d in ("mpg321", "mpg123"):
      self.child = popen2.Popen3("%s --skip-printing-frames=20 -R foo" % d)
      if self.child.poll() == -1:
        return

  def fileno(self):
    return self.child.fromchild.fileno()
 
  def update(self, doSelect=False, timeout=0):
    if doSelect:
      select.select([self],[],[], timeout)

    self.buf += os.read(self.child.fromchild.fileno(), 4096)
    while 1:
      eol = self.buf.find("\n")
      if eol == -1: break

      what, args = self.buf[:eol].split(None,1)

      self.buf = self.buf[eol+1:]

      if what == "@S":
        self.updateFields(args)
      elif what == "@F":
        self.updateFrameFields(args)
        self.totalTime = self.timeRemaining + self.currentTime
      elif (what,args) == ("@P","0"):
        self.quit()



  def cmd(self, cmd):
    #sys.stderr.write("Sending command: %s\n" % cmd)
    if self.done: return
    self.child.tochild.write("%s\n" % cmd)
    self.child.tochild.flush()

  def play(self):
    self.cmd("LOAD %s" % self.filename)
  def seek(self, offset):
    self.cmd("JUMP %s" % offset)
  def pause(self):
    self.cmd("PAUSE")

  def quit(self):
    self.cmd("QUIT")

    self.child.wait()

    self.buf = ""
    self.done = True


if __name__ == "__main__":
  if len(sys.argv) < 2 or not os.path.isfile(sys.argv[1]):
    print >>sys.stderr, "gimme a file"; sys.exit(1)

  m = Mp3(sys.argv[1])
  m.play()
  try:
    while not m.done: m.update()
  except KeyboardInterrupt:
    sys.exit(1)

