from threading import Thread, Event


class Repeater(Thread):
  """Inspired by the threading.Timer class"""

  def __init__(self, interval, function):
    Thread.__init__(self)
    self.interval = interval
    self.function = function
    self.finished = Event()

    self.setDaemon(True)

  def stop(self):
    self.finished.set()

  def run(self):
    while 1:
      self.finished.wait(self.interval)
      if not self.finished.isSet():
        self.function()
      else:
        break

    self.finished.set()

