import os, types, sys, time

from Thump.Values import Filenames, Vars
from Thump.Proc import Processes
from Thump import StrOps
import Read, Write

def rm(filename):
  try:
    os.unlink(filename)
    return 1
  except OSError:
    return 0

def rmPidFile():     return rm(Filenames.pidfile)
def rmFePidFile():   return rm(Filenames.fepidfile)
def rmInfoFile():    return rm(Filenames.infofile)
def rmOptionsFile(): return rm(Filenames.optionsfile)

def isUseableMp3(filename):
  return (filename.endswith("mp3") and os.path.isfile(filename)) and 1 or 0

def cleanFePidFile(rmpid=None):
  lines = Read.readFile(Filenames.fepidfile)
  newlines = []

  if lines == []: return

  for line in lines:
    try:
      alive = Processes.checkProcessForLife(int(line.strip()))
    except ValueError:
      continue

    if alive:
      if rmpid is not None:
        if int(line.strip()) != rmpid:
          newlines.append(StrOps.autoNewline(str(line).strip()))
      else:
        newlines.append(StrOps.autoNewline(str(line).strip()))

  u = []
  for x in newlines:
    if x not in u:
      u.append(x)

  Write.writeToFile(Filenames.fepidfile, "w", newlines)

def checkPlayListMtime():
  return os.path.getmtime(Filenames.listfile)

def checkErrFileWritability():
  if os.path.isfile(Filenames.error_log):
    if os.access(Filenames.error_log, os.W_OK):
      return Vars.WRITABLE
  else:
    try:
      open(filenames.error_log, "w").close()
      return Vars.WRITABLE
    except OSError:
      pass

  return Vars.UNWRITABLE

def NullDevice():
  def write(self, junk): pass

def ensureThumpDirExistence():
  if not os.path.exists(Filenames.thumpdir):
    try:
      os.mkdir(Filenames.thumpdir)
    except OSError:
      return 0
  return 1
