import os, types, sys, time

from Thump.Values import Filenames
from Thump import StrOps

def writeToFile(filename, mode, line_or_lines):
  thefile = open(filename, mode)

  if isinstance(line_or_lines, types.ListType):
    thefile.writelines( [ StrOps.autoNewline(str(line)) for line in line_or_lines ] )

  elif isinstance(line_or_lines, types.StringType):
    thefile.write(StrOps.autoNewline(str(line_or_lines)))

  thefile.close()
  return 1

def appendAccessLog(line):
  line = "%s :@@: %s" % (time.asctime(), line)
  return writeToFile(Filenames.access_log, "a", line)

def appendErrorLog(msg):
  line = "%s %s (%s): %s" % (time.asctime(), sys.argv[0].split("/")[-1], os.getpid(), msg)
  return writeToFile(Filenames.error_log, "a", line)

def writePidFile(pid):
  return writeToFile(Filenames.pidfile, "w", pid)

def writeFePidFile(pid):
  return writeToFile(Filenames.fepidfile, "a", StrOps.autoNewline(str(pid)))

def updateLiveFile(text):
  return writeToFile(Filenames.livefile, "w", text.strip())

