import os, sys

from Thump.Values import Filenames
from Thump.FileOps import Read

def getPlayerPid():
  lines = Read.readFile(Filenames.pidfile)
  if len(lines) > 0:
    pid = lines[0]

    try:
      return int(pid)
    except ValueError:
      pass
  return None

def getFePids():
  lines = Read.readFile(Filenames.fepidfile)

  if lines is None: return []

  pids = []
  for line in lines:
    try: 
      pids.append(int(line))
    except ValueError:
      pass

  return pids

def checkFesForLife():
  pids = getFePids()

  life = {}
  for pid in pids:
    if checkProcessForLife(pid):
      life[pid] = 1

  return life

def checkProcessForLife(pid):
  try:
    os.kill(pid, 0)
    return 1
  except OSError:
    return 0

def checkPlayerForLife():
  pid = getPlayerPid()
  return (pid and checkProcessForLife(pid)) and 1 or 0

def daemon(chdir, stdout, stderr):
  os.fork() and sys.exit(0)
  os.setsid()
  os.fork() and sys.exit(0)

  os.chdir(chdir)
  os.umask(0)

  sys.stdin.close()

  sys.stdout = stdout
  sys.stderr = stderr

